/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_PASSAGEOB_H
#define DPC_IMPL_TYPE_PASSAGEOB_H

#include <cfloat>
#include <cmath>
#include "dpc/impl_type_index.h"
#include "impl_type_uint32.h"
#include "dpc/impl_type_longitudinalinfo.h"
#include "impl_type_uint8.h"
#include "impl_type_float.h"
#include "dpc/impl_type_vector_uint32_t.h"
#include "impl_type_boolean.h"

namespace dpc {
struct PassageOb {
    ::dpc::Index passage_id;
    ::UInt32 corridor_id{ 0U };
    ::dpc::LongitudinalInfo longt_info;
    ::UInt8 action_type{ 0U };
    ::Float duration_time{ 0.0F };
    ::dpc::vector_uint32_t interest_obj_id_list;
    ::Float alcdis_egolane{ 0.0F };
    ::Float realcdis_egolane{ 0.0F };
    ::Float alcdis_tarlane_frt{ 0.0F };
    ::Float realcdis_tarlane_frt{ 0.0F };
    ::Float alcdis_tarlane_bck{ 0.0F };
    ::Float realcdis_tarlane_bck{ 0.0F };
    ::Float lc_tar_frt_obj_dist_nrst{ 0.0F };
    ::Float lc_tar_bck_obj_dist_nrst{ 0.0F };
    ::Boolean lc_passagegenflg{ false };
    ::Boolean lc_lne_chg_res0{ false };
    ::Boolean lc_lne_chg_res1{ false };
    ::Boolean lc_lne_chg_res2{ false };
    ::Boolean lc_lne_chg_res3{ false };
    ::Boolean lc_ego_frt_obj_exist_flg{ false };
    ::UInt8 lc_cls{ 0U };
    ::UInt32 lc_ego_frt_obj_id{ 0U };
    ::Float lc_ego_frt_obj_dist{ 0.0F };
    ::Float lc_ego_frt_obj_spd{ 0.0F };
    ::Float lc_ego_frt_obj_len{ 0.0F };
    ::UInt32 lc_ego_frt_obj_cls{ 0U };
    ::Boolean lc_tar_frt_obj_exist_flg{ false };
    ::UInt32 lc_tar_frt_obj_id{ 0U };
    ::Float lc_tar_frt_obj_dist{ 0.0F };
    ::Float lc_tar_frt_obj_spd{ 0.0F };
    ::Float lc_tar_frt_obj_len{ 0.0F };
    ::UInt32 lc_tar_frt_obj_cls{ 0U };
    ::Boolean lc_tar_bck_obj_exist_flg{ false };
    ::UInt32 lc_tar_bck_obj_id{ 0U };
    ::Float lc_tar_bck_obj_dist{ 0.0F };
    ::Float lc_tar_bck_obj_spd{ 0.0F };
    ::Float lc_tar_bck_obj_len{ 0.0F };
    ::UInt32 lc_tar_bck_obj_cls{ 0U };
    ::Boolean lcp_frt_passagegenflg{ false };
    ::Boolean lcp_bck_passagegenflg{ false };
    ::Boolean lcp_ego_frt_obj_exist_flg{ false };
    ::Float frt_lcp_dis_tarlane_egofrt_raw{ 0.0F };
    ::Float frt_lcp_dis_tarlane_egobck_raw{ 0.0F };
    ::Float bck_lcp_dis_tarlane_egofrt_raw{ 0.0F };
    ::Float bck_lcp_dis_tarlane_egobck_raw{ 0.0F };
    ::Float frt_lcp_dis_tarlane_egofrt{ 0.0F };
    ::Float frt_lcp_dis_tarlane_egobck{ 0.0F };
    ::Float bck_lcp_dis_tarlane_egofrt{ 0.0F };
    ::Float bck_lcp_dis_tarlane_egobck{ 0.0F };
    ::UInt8 lcp_cls_frt{ 0U };
    ::UInt8 lcp_cls_bck{ 0U };
    ::Float lcp_frt_mov_dist{ 0.0F };
    ::Float lcp_frt_ego_lne_space{ 0.0F };
    ::Float lcp_frt_est_space{ 0.0F };
    ::Float lcp_frt_nd_space{ 0.0F };
    ::Float lcp_bck_mov_dist{ 0.0F };
    ::Float lcp_bck_ego_lne_space{ 0.0F };
    ::Float lcp_bck_est_space{ 0.0F };
    ::Float lcp_bck_nd_space{ 0.0F };
    ::Float lcp_frt_ego_arv_est_tm{ 0.0F };
    ::Float lcp_frt_ego_region_dist{ 0.0F };
    ::Float lcp_bck_ego_arv_est_tm{ 0.0F };
    ::Float lcp_bck_ego_region_dist{ 0.0F };
    ::Boolean lcp_frt_lne_chg_pr_res1{ false };
    ::Boolean lcp_frt_lne_chg_pr_res2{ false };
    ::Boolean lcp_frt_lne_chg_pr_res3{ false };
    ::Boolean lcp_frt_lne_chg_pr_res4{ false };
    ::Boolean lcp_bck_lne_chg_pr_res1{ false };
    ::Boolean lcp_bck_lne_chg_pr_res2{ false };
    ::Boolean lcp_bck_lne_chg_pr_res3{ false };
    ::Boolean lcp_bck_lne_chg_pr_res4{ false };
    ::UInt32 lcp_ego_frt_obj_id{ 0U };
    ::Float lcp_ego_frt_obj_dist{ 0.0F };
    ::Float lcp_ego_frt_obj_spd{ 0.0F };
    ::Float lcp_ego_frt_obj_len{ 0.0F };
    ::UInt32 lcp_ego_frt_obj_cls{ 0U };
    ::Boolean lcp_ego_bck_obj_exist_flg{ false };
    ::UInt32 lcp_ego_bck_obj_id{ 0U };
    ::Float lcp_ego_bck_obj_dist{ 0.0F };
    ::Float lcp_ego_bck_obj_spd{ 0.0F };
    ::Float lcp_ego_bck_obj_len{ 0.0F };
    ::UInt32 lcp_ego_bck_obj_cls{ 0U };
    ::Boolean lcp_nr_obj_exist_flg{ false };
    ::UInt32 lcp_nr_obj_id{ 0U };
    ::Float lcp_nr_obj_dist{ 0.0F };
    ::Float lcp_nr_obj_spd{ 0.0F };
    ::Float lcp_nr_obj_len{ 0.0F };
    ::UInt32 lcp_nr_obj_cls{ 0U };
    ::Boolean lcp_nr_frt_obj_exist_flg{ false };
    ::UInt32 lcp_nr_frt_obj_id{ 0U };
    ::Float lcp_nr_frt_obj_dist{ 0.0F };
    ::Float lcp_nr_frt_obj_spd{ 0.0F };
    ::Float lcp_nr_frt_obj_len{ 0.0F };
    ::UInt32 lcp_nr_frt_obj_cls{ 0U };
    ::Boolean lcp_nr_bck_obj_exist_flg{ false };
    ::UInt32 lcp_nr_bck_obj_id{ 0U };
    ::Float lcp_nr_bck_obj_dist{ 0.0F };
    ::Float lcp_nr_bck_obj_spd{ 0.0F };
    ::Float lcp_nr_bck_obj_len{ 0.0F };
    ::UInt32 lcp_nr_bck_obj_cls{ 0U };

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(passage_id);
        fun(corridor_id);
        fun(longt_info);
        fun(action_type);
        fun(duration_time);
        fun(interest_obj_id_list);
        fun(alcdis_egolane);
        fun(realcdis_egolane);
        fun(alcdis_tarlane_frt);
        fun(realcdis_tarlane_frt);
        fun(alcdis_tarlane_bck);
        fun(realcdis_tarlane_bck);
        fun(lc_tar_frt_obj_dist_nrst);
        fun(lc_tar_bck_obj_dist_nrst);
        fun(lc_passagegenflg);
        fun(lc_lne_chg_res0);
        fun(lc_lne_chg_res1);
        fun(lc_lne_chg_res2);
        fun(lc_lne_chg_res3);
        fun(lc_ego_frt_obj_exist_flg);
        fun(lc_cls);
        fun(lc_ego_frt_obj_id);
        fun(lc_ego_frt_obj_dist);
        fun(lc_ego_frt_obj_spd);
        fun(lc_ego_frt_obj_len);
        fun(lc_ego_frt_obj_cls);
        fun(lc_tar_frt_obj_exist_flg);
        fun(lc_tar_frt_obj_id);
        fun(lc_tar_frt_obj_dist);
        fun(lc_tar_frt_obj_spd);
        fun(lc_tar_frt_obj_len);
        fun(lc_tar_frt_obj_cls);
        fun(lc_tar_bck_obj_exist_flg);
        fun(lc_tar_bck_obj_id);
        fun(lc_tar_bck_obj_dist);
        fun(lc_tar_bck_obj_spd);
        fun(lc_tar_bck_obj_len);
        fun(lc_tar_bck_obj_cls);
        fun(lcp_frt_passagegenflg);
        fun(lcp_bck_passagegenflg);
        fun(lcp_ego_frt_obj_exist_flg);
        fun(frt_lcp_dis_tarlane_egofrt_raw);
        fun(frt_lcp_dis_tarlane_egobck_raw);
        fun(bck_lcp_dis_tarlane_egofrt_raw);
        fun(bck_lcp_dis_tarlane_egobck_raw);
        fun(frt_lcp_dis_tarlane_egofrt);
        fun(frt_lcp_dis_tarlane_egobck);
        fun(bck_lcp_dis_tarlane_egofrt);
        fun(bck_lcp_dis_tarlane_egobck);
        fun(lcp_cls_frt);
        fun(lcp_cls_bck);
        fun(lcp_frt_mov_dist);
        fun(lcp_frt_ego_lne_space);
        fun(lcp_frt_est_space);
        fun(lcp_frt_nd_space);
        fun(lcp_bck_mov_dist);
        fun(lcp_bck_ego_lne_space);
        fun(lcp_bck_est_space);
        fun(lcp_bck_nd_space);
        fun(lcp_frt_ego_arv_est_tm);
        fun(lcp_frt_ego_region_dist);
        fun(lcp_bck_ego_arv_est_tm);
        fun(lcp_bck_ego_region_dist);
        fun(lcp_frt_lne_chg_pr_res1);
        fun(lcp_frt_lne_chg_pr_res2);
        fun(lcp_frt_lne_chg_pr_res3);
        fun(lcp_frt_lne_chg_pr_res4);
        fun(lcp_bck_lne_chg_pr_res1);
        fun(lcp_bck_lne_chg_pr_res2);
        fun(lcp_bck_lne_chg_pr_res3);
        fun(lcp_bck_lne_chg_pr_res4);
        fun(lcp_ego_frt_obj_id);
        fun(lcp_ego_frt_obj_dist);
        fun(lcp_ego_frt_obj_spd);
        fun(lcp_ego_frt_obj_len);
        fun(lcp_ego_frt_obj_cls);
        fun(lcp_ego_bck_obj_exist_flg);
        fun(lcp_ego_bck_obj_id);
        fun(lcp_ego_bck_obj_dist);
        fun(lcp_ego_bck_obj_spd);
        fun(lcp_ego_bck_obj_len);
        fun(lcp_ego_bck_obj_cls);
        fun(lcp_nr_obj_exist_flg);
        fun(lcp_nr_obj_id);
        fun(lcp_nr_obj_dist);
        fun(lcp_nr_obj_spd);
        fun(lcp_nr_obj_len);
        fun(lcp_nr_obj_cls);
        fun(lcp_nr_frt_obj_exist_flg);
        fun(lcp_nr_frt_obj_id);
        fun(lcp_nr_frt_obj_dist);
        fun(lcp_nr_frt_obj_spd);
        fun(lcp_nr_frt_obj_len);
        fun(lcp_nr_frt_obj_cls);
        fun(lcp_nr_bck_obj_exist_flg);
        fun(lcp_nr_bck_obj_id);
        fun(lcp_nr_bck_obj_dist);
        fun(lcp_nr_bck_obj_spd);
        fun(lcp_nr_bck_obj_len);
        fun(lcp_nr_bck_obj_cls);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(passage_id);
        fun(corridor_id);
        fun(longt_info);
        fun(action_type);
        fun(duration_time);
        fun(interest_obj_id_list);
        fun(alcdis_egolane);
        fun(realcdis_egolane);
        fun(alcdis_tarlane_frt);
        fun(realcdis_tarlane_frt);
        fun(alcdis_tarlane_bck);
        fun(realcdis_tarlane_bck);
        fun(lc_tar_frt_obj_dist_nrst);
        fun(lc_tar_bck_obj_dist_nrst);
        fun(lc_passagegenflg);
        fun(lc_lne_chg_res0);
        fun(lc_lne_chg_res1);
        fun(lc_lne_chg_res2);
        fun(lc_lne_chg_res3);
        fun(lc_ego_frt_obj_exist_flg);
        fun(lc_cls);
        fun(lc_ego_frt_obj_id);
        fun(lc_ego_frt_obj_dist);
        fun(lc_ego_frt_obj_spd);
        fun(lc_ego_frt_obj_len);
        fun(lc_ego_frt_obj_cls);
        fun(lc_tar_frt_obj_exist_flg);
        fun(lc_tar_frt_obj_id);
        fun(lc_tar_frt_obj_dist);
        fun(lc_tar_frt_obj_spd);
        fun(lc_tar_frt_obj_len);
        fun(lc_tar_frt_obj_cls);
        fun(lc_tar_bck_obj_exist_flg);
        fun(lc_tar_bck_obj_id);
        fun(lc_tar_bck_obj_dist);
        fun(lc_tar_bck_obj_spd);
        fun(lc_tar_bck_obj_len);
        fun(lc_tar_bck_obj_cls);
        fun(lcp_frt_passagegenflg);
        fun(lcp_bck_passagegenflg);
        fun(lcp_ego_frt_obj_exist_flg);
        fun(frt_lcp_dis_tarlane_egofrt_raw);
        fun(frt_lcp_dis_tarlane_egobck_raw);
        fun(bck_lcp_dis_tarlane_egofrt_raw);
        fun(bck_lcp_dis_tarlane_egobck_raw);
        fun(frt_lcp_dis_tarlane_egofrt);
        fun(frt_lcp_dis_tarlane_egobck);
        fun(bck_lcp_dis_tarlane_egofrt);
        fun(bck_lcp_dis_tarlane_egobck);
        fun(lcp_cls_frt);
        fun(lcp_cls_bck);
        fun(lcp_frt_mov_dist);
        fun(lcp_frt_ego_lne_space);
        fun(lcp_frt_est_space);
        fun(lcp_frt_nd_space);
        fun(lcp_bck_mov_dist);
        fun(lcp_bck_ego_lne_space);
        fun(lcp_bck_est_space);
        fun(lcp_bck_nd_space);
        fun(lcp_frt_ego_arv_est_tm);
        fun(lcp_frt_ego_region_dist);
        fun(lcp_bck_ego_arv_est_tm);
        fun(lcp_bck_ego_region_dist);
        fun(lcp_frt_lne_chg_pr_res1);
        fun(lcp_frt_lne_chg_pr_res2);
        fun(lcp_frt_lne_chg_pr_res3);
        fun(lcp_frt_lne_chg_pr_res4);
        fun(lcp_bck_lne_chg_pr_res1);
        fun(lcp_bck_lne_chg_pr_res2);
        fun(lcp_bck_lne_chg_pr_res3);
        fun(lcp_bck_lne_chg_pr_res4);
        fun(lcp_ego_frt_obj_id);
        fun(lcp_ego_frt_obj_dist);
        fun(lcp_ego_frt_obj_spd);
        fun(lcp_ego_frt_obj_len);
        fun(lcp_ego_frt_obj_cls);
        fun(lcp_ego_bck_obj_exist_flg);
        fun(lcp_ego_bck_obj_id);
        fun(lcp_ego_bck_obj_dist);
        fun(lcp_ego_bck_obj_spd);
        fun(lcp_ego_bck_obj_len);
        fun(lcp_ego_bck_obj_cls);
        fun(lcp_nr_obj_exist_flg);
        fun(lcp_nr_obj_id);
        fun(lcp_nr_obj_dist);
        fun(lcp_nr_obj_spd);
        fun(lcp_nr_obj_len);
        fun(lcp_nr_obj_cls);
        fun(lcp_nr_frt_obj_exist_flg);
        fun(lcp_nr_frt_obj_id);
        fun(lcp_nr_frt_obj_dist);
        fun(lcp_nr_frt_obj_spd);
        fun(lcp_nr_frt_obj_len);
        fun(lcp_nr_frt_obj_cls);
        fun(lcp_nr_bck_obj_exist_flg);
        fun(lcp_nr_bck_obj_id);
        fun(lcp_nr_bck_obj_dist);
        fun(lcp_nr_bck_obj_spd);
        fun(lcp_nr_bck_obj_len);
        fun(lcp_nr_bck_obj_cls);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("passage_id", passage_id);
        fun("corridor_id", corridor_id);
        fun("longt_info", longt_info);
        fun("action_type", action_type);
        fun("duration_time", duration_time);
        fun("interest_obj_id_list", interest_obj_id_list);
        fun("alcdis_egolane", alcdis_egolane);
        fun("realcdis_egolane", realcdis_egolane);
        fun("alcdis_tarlane_frt", alcdis_tarlane_frt);
        fun("realcdis_tarlane_frt", realcdis_tarlane_frt);
        fun("alcdis_tarlane_bck", alcdis_tarlane_bck);
        fun("realcdis_tarlane_bck", realcdis_tarlane_bck);
        fun("lc_tar_frt_obj_dist_nrst", lc_tar_frt_obj_dist_nrst);
        fun("lc_tar_bck_obj_dist_nrst", lc_tar_bck_obj_dist_nrst);
        fun("lc_passagegenflg", lc_passagegenflg);
        fun("lc_lne_chg_res0", lc_lne_chg_res0);
        fun("lc_lne_chg_res1", lc_lne_chg_res1);
        fun("lc_lne_chg_res2", lc_lne_chg_res2);
        fun("lc_lne_chg_res3", lc_lne_chg_res3);
        fun("lc_ego_frt_obj_exist_flg", lc_ego_frt_obj_exist_flg);
        fun("lc_cls", lc_cls);
        fun("lc_ego_frt_obj_id", lc_ego_frt_obj_id);
        fun("lc_ego_frt_obj_dist", lc_ego_frt_obj_dist);
        fun("lc_ego_frt_obj_spd", lc_ego_frt_obj_spd);
        fun("lc_ego_frt_obj_len", lc_ego_frt_obj_len);
        fun("lc_ego_frt_obj_cls", lc_ego_frt_obj_cls);
        fun("lc_tar_frt_obj_exist_flg", lc_tar_frt_obj_exist_flg);
        fun("lc_tar_frt_obj_id", lc_tar_frt_obj_id);
        fun("lc_tar_frt_obj_dist", lc_tar_frt_obj_dist);
        fun("lc_tar_frt_obj_spd", lc_tar_frt_obj_spd);
        fun("lc_tar_frt_obj_len", lc_tar_frt_obj_len);
        fun("lc_tar_frt_obj_cls", lc_tar_frt_obj_cls);
        fun("lc_tar_bck_obj_exist_flg", lc_tar_bck_obj_exist_flg);
        fun("lc_tar_bck_obj_id", lc_tar_bck_obj_id);
        fun("lc_tar_bck_obj_dist", lc_tar_bck_obj_dist);
        fun("lc_tar_bck_obj_spd", lc_tar_bck_obj_spd);
        fun("lc_tar_bck_obj_len", lc_tar_bck_obj_len);
        fun("lc_tar_bck_obj_cls", lc_tar_bck_obj_cls);
        fun("lcp_frt_passagegenflg", lcp_frt_passagegenflg);
        fun("lcp_bck_passagegenflg", lcp_bck_passagegenflg);
        fun("lcp_ego_frt_obj_exist_flg", lcp_ego_frt_obj_exist_flg);
        fun("frt_lcp_dis_tarlane_egofrt_raw", frt_lcp_dis_tarlane_egofrt_raw);
        fun("frt_lcp_dis_tarlane_egobck_raw", frt_lcp_dis_tarlane_egobck_raw);
        fun("bck_lcp_dis_tarlane_egofrt_raw", bck_lcp_dis_tarlane_egofrt_raw);
        fun("bck_lcp_dis_tarlane_egobck_raw", bck_lcp_dis_tarlane_egobck_raw);
        fun("frt_lcp_dis_tarlane_egofrt", frt_lcp_dis_tarlane_egofrt);
        fun("frt_lcp_dis_tarlane_egobck", frt_lcp_dis_tarlane_egobck);
        fun("bck_lcp_dis_tarlane_egofrt", bck_lcp_dis_tarlane_egofrt);
        fun("bck_lcp_dis_tarlane_egobck", bck_lcp_dis_tarlane_egobck);
        fun("lcp_cls_frt", lcp_cls_frt);
        fun("lcp_cls_bck", lcp_cls_bck);
        fun("lcp_frt_mov_dist", lcp_frt_mov_dist);
        fun("lcp_frt_ego_lne_space", lcp_frt_ego_lne_space);
        fun("lcp_frt_est_space", lcp_frt_est_space);
        fun("lcp_frt_nd_space", lcp_frt_nd_space);
        fun("lcp_bck_mov_dist", lcp_bck_mov_dist);
        fun("lcp_bck_ego_lne_space", lcp_bck_ego_lne_space);
        fun("lcp_bck_est_space", lcp_bck_est_space);
        fun("lcp_bck_nd_space", lcp_bck_nd_space);
        fun("lcp_frt_ego_arv_est_tm", lcp_frt_ego_arv_est_tm);
        fun("lcp_frt_ego_region_dist", lcp_frt_ego_region_dist);
        fun("lcp_bck_ego_arv_est_tm", lcp_bck_ego_arv_est_tm);
        fun("lcp_bck_ego_region_dist", lcp_bck_ego_region_dist);
        fun("lcp_frt_lne_chg_pr_res1", lcp_frt_lne_chg_pr_res1);
        fun("lcp_frt_lne_chg_pr_res2", lcp_frt_lne_chg_pr_res2);
        fun("lcp_frt_lne_chg_pr_res3", lcp_frt_lne_chg_pr_res3);
        fun("lcp_frt_lne_chg_pr_res4", lcp_frt_lne_chg_pr_res4);
        fun("lcp_bck_lne_chg_pr_res1", lcp_bck_lne_chg_pr_res1);
        fun("lcp_bck_lne_chg_pr_res2", lcp_bck_lne_chg_pr_res2);
        fun("lcp_bck_lne_chg_pr_res3", lcp_bck_lne_chg_pr_res3);
        fun("lcp_bck_lne_chg_pr_res4", lcp_bck_lne_chg_pr_res4);
        fun("lcp_ego_frt_obj_id", lcp_ego_frt_obj_id);
        fun("lcp_ego_frt_obj_dist", lcp_ego_frt_obj_dist);
        fun("lcp_ego_frt_obj_spd", lcp_ego_frt_obj_spd);
        fun("lcp_ego_frt_obj_len", lcp_ego_frt_obj_len);
        fun("lcp_ego_frt_obj_cls", lcp_ego_frt_obj_cls);
        fun("lcp_ego_bck_obj_exist_flg", lcp_ego_bck_obj_exist_flg);
        fun("lcp_ego_bck_obj_id", lcp_ego_bck_obj_id);
        fun("lcp_ego_bck_obj_dist", lcp_ego_bck_obj_dist);
        fun("lcp_ego_bck_obj_spd", lcp_ego_bck_obj_spd);
        fun("lcp_ego_bck_obj_len", lcp_ego_bck_obj_len);
        fun("lcp_ego_bck_obj_cls", lcp_ego_bck_obj_cls);
        fun("lcp_nr_obj_exist_flg", lcp_nr_obj_exist_flg);
        fun("lcp_nr_obj_id", lcp_nr_obj_id);
        fun("lcp_nr_obj_dist", lcp_nr_obj_dist);
        fun("lcp_nr_obj_spd", lcp_nr_obj_spd);
        fun("lcp_nr_obj_len", lcp_nr_obj_len);
        fun("lcp_nr_obj_cls", lcp_nr_obj_cls);
        fun("lcp_nr_frt_obj_exist_flg", lcp_nr_frt_obj_exist_flg);
        fun("lcp_nr_frt_obj_id", lcp_nr_frt_obj_id);
        fun("lcp_nr_frt_obj_dist", lcp_nr_frt_obj_dist);
        fun("lcp_nr_frt_obj_spd", lcp_nr_frt_obj_spd);
        fun("lcp_nr_frt_obj_len", lcp_nr_frt_obj_len);
        fun("lcp_nr_frt_obj_cls", lcp_nr_frt_obj_cls);
        fun("lcp_nr_bck_obj_exist_flg", lcp_nr_bck_obj_exist_flg);
        fun("lcp_nr_bck_obj_id", lcp_nr_bck_obj_id);
        fun("lcp_nr_bck_obj_dist", lcp_nr_bck_obj_dist);
        fun("lcp_nr_bck_obj_spd", lcp_nr_bck_obj_spd);
        fun("lcp_nr_bck_obj_len", lcp_nr_bck_obj_len);
        fun("lcp_nr_bck_obj_cls", lcp_nr_bck_obj_cls);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("passage_id", passage_id);
        fun("corridor_id", corridor_id);
        fun("longt_info", longt_info);
        fun("action_type", action_type);
        fun("duration_time", duration_time);
        fun("interest_obj_id_list", interest_obj_id_list);
        fun("alcdis_egolane", alcdis_egolane);
        fun("realcdis_egolane", realcdis_egolane);
        fun("alcdis_tarlane_frt", alcdis_tarlane_frt);
        fun("realcdis_tarlane_frt", realcdis_tarlane_frt);
        fun("alcdis_tarlane_bck", alcdis_tarlane_bck);
        fun("realcdis_tarlane_bck", realcdis_tarlane_bck);
        fun("lc_tar_frt_obj_dist_nrst", lc_tar_frt_obj_dist_nrst);
        fun("lc_tar_bck_obj_dist_nrst", lc_tar_bck_obj_dist_nrst);
        fun("lc_passagegenflg", lc_passagegenflg);
        fun("lc_lne_chg_res0", lc_lne_chg_res0);
        fun("lc_lne_chg_res1", lc_lne_chg_res1);
        fun("lc_lne_chg_res2", lc_lne_chg_res2);
        fun("lc_lne_chg_res3", lc_lne_chg_res3);
        fun("lc_ego_frt_obj_exist_flg", lc_ego_frt_obj_exist_flg);
        fun("lc_cls", lc_cls);
        fun("lc_ego_frt_obj_id", lc_ego_frt_obj_id);
        fun("lc_ego_frt_obj_dist", lc_ego_frt_obj_dist);
        fun("lc_ego_frt_obj_spd", lc_ego_frt_obj_spd);
        fun("lc_ego_frt_obj_len", lc_ego_frt_obj_len);
        fun("lc_ego_frt_obj_cls", lc_ego_frt_obj_cls);
        fun("lc_tar_frt_obj_exist_flg", lc_tar_frt_obj_exist_flg);
        fun("lc_tar_frt_obj_id", lc_tar_frt_obj_id);
        fun("lc_tar_frt_obj_dist", lc_tar_frt_obj_dist);
        fun("lc_tar_frt_obj_spd", lc_tar_frt_obj_spd);
        fun("lc_tar_frt_obj_len", lc_tar_frt_obj_len);
        fun("lc_tar_frt_obj_cls", lc_tar_frt_obj_cls);
        fun("lc_tar_bck_obj_exist_flg", lc_tar_bck_obj_exist_flg);
        fun("lc_tar_bck_obj_id", lc_tar_bck_obj_id);
        fun("lc_tar_bck_obj_dist", lc_tar_bck_obj_dist);
        fun("lc_tar_bck_obj_spd", lc_tar_bck_obj_spd);
        fun("lc_tar_bck_obj_len", lc_tar_bck_obj_len);
        fun("lc_tar_bck_obj_cls", lc_tar_bck_obj_cls);
        fun("lcp_frt_passagegenflg", lcp_frt_passagegenflg);
        fun("lcp_bck_passagegenflg", lcp_bck_passagegenflg);
        fun("lcp_ego_frt_obj_exist_flg", lcp_ego_frt_obj_exist_flg);
        fun("frt_lcp_dis_tarlane_egofrt_raw", frt_lcp_dis_tarlane_egofrt_raw);
        fun("frt_lcp_dis_tarlane_egobck_raw", frt_lcp_dis_tarlane_egobck_raw);
        fun("bck_lcp_dis_tarlane_egofrt_raw", bck_lcp_dis_tarlane_egofrt_raw);
        fun("bck_lcp_dis_tarlane_egobck_raw", bck_lcp_dis_tarlane_egobck_raw);
        fun("frt_lcp_dis_tarlane_egofrt", frt_lcp_dis_tarlane_egofrt);
        fun("frt_lcp_dis_tarlane_egobck", frt_lcp_dis_tarlane_egobck);
        fun("bck_lcp_dis_tarlane_egofrt", bck_lcp_dis_tarlane_egofrt);
        fun("bck_lcp_dis_tarlane_egobck", bck_lcp_dis_tarlane_egobck);
        fun("lcp_cls_frt", lcp_cls_frt);
        fun("lcp_cls_bck", lcp_cls_bck);
        fun("lcp_frt_mov_dist", lcp_frt_mov_dist);
        fun("lcp_frt_ego_lne_space", lcp_frt_ego_lne_space);
        fun("lcp_frt_est_space", lcp_frt_est_space);
        fun("lcp_frt_nd_space", lcp_frt_nd_space);
        fun("lcp_bck_mov_dist", lcp_bck_mov_dist);
        fun("lcp_bck_ego_lne_space", lcp_bck_ego_lne_space);
        fun("lcp_bck_est_space", lcp_bck_est_space);
        fun("lcp_bck_nd_space", lcp_bck_nd_space);
        fun("lcp_frt_ego_arv_est_tm", lcp_frt_ego_arv_est_tm);
        fun("lcp_frt_ego_region_dist", lcp_frt_ego_region_dist);
        fun("lcp_bck_ego_arv_est_tm", lcp_bck_ego_arv_est_tm);
        fun("lcp_bck_ego_region_dist", lcp_bck_ego_region_dist);
        fun("lcp_frt_lne_chg_pr_res1", lcp_frt_lne_chg_pr_res1);
        fun("lcp_frt_lne_chg_pr_res2", lcp_frt_lne_chg_pr_res2);
        fun("lcp_frt_lne_chg_pr_res3", lcp_frt_lne_chg_pr_res3);
        fun("lcp_frt_lne_chg_pr_res4", lcp_frt_lne_chg_pr_res4);
        fun("lcp_bck_lne_chg_pr_res1", lcp_bck_lne_chg_pr_res1);
        fun("lcp_bck_lne_chg_pr_res2", lcp_bck_lne_chg_pr_res2);
        fun("lcp_bck_lne_chg_pr_res3", lcp_bck_lne_chg_pr_res3);
        fun("lcp_bck_lne_chg_pr_res4", lcp_bck_lne_chg_pr_res4);
        fun("lcp_ego_frt_obj_id", lcp_ego_frt_obj_id);
        fun("lcp_ego_frt_obj_dist", lcp_ego_frt_obj_dist);
        fun("lcp_ego_frt_obj_spd", lcp_ego_frt_obj_spd);
        fun("lcp_ego_frt_obj_len", lcp_ego_frt_obj_len);
        fun("lcp_ego_frt_obj_cls", lcp_ego_frt_obj_cls);
        fun("lcp_ego_bck_obj_exist_flg", lcp_ego_bck_obj_exist_flg);
        fun("lcp_ego_bck_obj_id", lcp_ego_bck_obj_id);
        fun("lcp_ego_bck_obj_dist", lcp_ego_bck_obj_dist);
        fun("lcp_ego_bck_obj_spd", lcp_ego_bck_obj_spd);
        fun("lcp_ego_bck_obj_len", lcp_ego_bck_obj_len);
        fun("lcp_ego_bck_obj_cls", lcp_ego_bck_obj_cls);
        fun("lcp_nr_obj_exist_flg", lcp_nr_obj_exist_flg);
        fun("lcp_nr_obj_id", lcp_nr_obj_id);
        fun("lcp_nr_obj_dist", lcp_nr_obj_dist);
        fun("lcp_nr_obj_spd", lcp_nr_obj_spd);
        fun("lcp_nr_obj_len", lcp_nr_obj_len);
        fun("lcp_nr_obj_cls", lcp_nr_obj_cls);
        fun("lcp_nr_frt_obj_exist_flg", lcp_nr_frt_obj_exist_flg);
        fun("lcp_nr_frt_obj_id", lcp_nr_frt_obj_id);
        fun("lcp_nr_frt_obj_dist", lcp_nr_frt_obj_dist);
        fun("lcp_nr_frt_obj_spd", lcp_nr_frt_obj_spd);
        fun("lcp_nr_frt_obj_len", lcp_nr_frt_obj_len);
        fun("lcp_nr_frt_obj_cls", lcp_nr_frt_obj_cls);
        fun("lcp_nr_bck_obj_exist_flg", lcp_nr_bck_obj_exist_flg);
        fun("lcp_nr_bck_obj_id", lcp_nr_bck_obj_id);
        fun("lcp_nr_bck_obj_dist", lcp_nr_bck_obj_dist);
        fun("lcp_nr_bck_obj_spd", lcp_nr_bck_obj_spd);
        fun("lcp_nr_bck_obj_len", lcp_nr_bck_obj_len);
        fun("lcp_nr_bck_obj_cls", lcp_nr_bck_obj_cls);
    }

    friend bool operator==(const ::dpc::PassageOb& lhs, const ::dpc::PassageOb& rhs) noexcept
    {
        return (lhs.passage_id == rhs.passage_id) && (lhs.corridor_id == rhs.corridor_id) && (lhs.longt_info == rhs.longt_info) && (lhs.action_type == rhs.action_type) && (fabs(static_cast<double>(lhs.duration_time - rhs.duration_time)) < DBL_EPSILON) && (lhs.interest_obj_id_list == rhs.interest_obj_id_list) && (fabs(static_cast<double>(lhs.alcdis_egolane - rhs.alcdis_egolane)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.realcdis_egolane - rhs.realcdis_egolane)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.alcdis_tarlane_frt - rhs.alcdis_tarlane_frt)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.realcdis_tarlane_frt - rhs.realcdis_tarlane_frt)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.alcdis_tarlane_bck - rhs.alcdis_tarlane_bck)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.realcdis_tarlane_bck - rhs.realcdis_tarlane_bck)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lc_tar_frt_obj_dist_nrst - rhs.lc_tar_frt_obj_dist_nrst)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lc_tar_bck_obj_dist_nrst - rhs.lc_tar_bck_obj_dist_nrst)) < DBL_EPSILON) && (lhs.lc_passagegenflg == rhs.lc_passagegenflg) && (lhs.lc_lne_chg_res0 == rhs.lc_lne_chg_res0) && (lhs.lc_lne_chg_res1 == rhs.lc_lne_chg_res1) && (lhs.lc_lne_chg_res2 == rhs.lc_lne_chg_res2) && (lhs.lc_lne_chg_res3 == rhs.lc_lne_chg_res3) && (lhs.lc_ego_frt_obj_exist_flg == rhs.lc_ego_frt_obj_exist_flg) && (lhs.lc_cls == rhs.lc_cls) && (lhs.lc_ego_frt_obj_id == rhs.lc_ego_frt_obj_id) && (fabs(static_cast<double>(lhs.lc_ego_frt_obj_dist - rhs.lc_ego_frt_obj_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lc_ego_frt_obj_spd - rhs.lc_ego_frt_obj_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lc_ego_frt_obj_len - rhs.lc_ego_frt_obj_len)) < DBL_EPSILON) && (lhs.lc_ego_frt_obj_cls == rhs.lc_ego_frt_obj_cls) && (lhs.lc_tar_frt_obj_exist_flg == rhs.lc_tar_frt_obj_exist_flg) && (lhs.lc_tar_frt_obj_id == rhs.lc_tar_frt_obj_id) && (fabs(static_cast<double>(lhs.lc_tar_frt_obj_dist - rhs.lc_tar_frt_obj_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lc_tar_frt_obj_spd - rhs.lc_tar_frt_obj_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lc_tar_frt_obj_len - rhs.lc_tar_frt_obj_len)) < DBL_EPSILON) && (lhs.lc_tar_frt_obj_cls == rhs.lc_tar_frt_obj_cls) && (lhs.lc_tar_bck_obj_exist_flg == rhs.lc_tar_bck_obj_exist_flg) && (lhs.lc_tar_bck_obj_id == rhs.lc_tar_bck_obj_id) && (fabs(static_cast<double>(lhs.lc_tar_bck_obj_dist - rhs.lc_tar_bck_obj_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lc_tar_bck_obj_spd - rhs.lc_tar_bck_obj_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lc_tar_bck_obj_len - rhs.lc_tar_bck_obj_len)) < DBL_EPSILON) && (lhs.lc_tar_bck_obj_cls == rhs.lc_tar_bck_obj_cls) && (lhs.lcp_frt_passagegenflg == rhs.lcp_frt_passagegenflg) && (lhs.lcp_bck_passagegenflg == rhs.lcp_bck_passagegenflg) && (lhs.lcp_ego_frt_obj_exist_flg == rhs.lcp_ego_frt_obj_exist_flg) && (fabs(static_cast<double>(lhs.frt_lcp_dis_tarlane_egofrt_raw - rhs.frt_lcp_dis_tarlane_egofrt_raw)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.frt_lcp_dis_tarlane_egobck_raw - rhs.frt_lcp_dis_tarlane_egobck_raw)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.bck_lcp_dis_tarlane_egofrt_raw - rhs.bck_lcp_dis_tarlane_egofrt_raw)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.bck_lcp_dis_tarlane_egobck_raw - rhs.bck_lcp_dis_tarlane_egobck_raw)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.frt_lcp_dis_tarlane_egofrt - rhs.frt_lcp_dis_tarlane_egofrt)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.frt_lcp_dis_tarlane_egobck - rhs.frt_lcp_dis_tarlane_egobck)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.bck_lcp_dis_tarlane_egofrt - rhs.bck_lcp_dis_tarlane_egofrt)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.bck_lcp_dis_tarlane_egobck - rhs.bck_lcp_dis_tarlane_egobck)) < DBL_EPSILON) && (lhs.lcp_cls_frt == rhs.lcp_cls_frt) && (lhs.lcp_cls_bck == rhs.lcp_cls_bck) && (fabs(static_cast<double>(lhs.lcp_frt_mov_dist - rhs.lcp_frt_mov_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_frt_ego_lne_space - rhs.lcp_frt_ego_lne_space)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_frt_est_space - rhs.lcp_frt_est_space)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_frt_nd_space - rhs.lcp_frt_nd_space)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_bck_mov_dist - rhs.lcp_bck_mov_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_bck_ego_lne_space - rhs.lcp_bck_ego_lne_space)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_bck_est_space - rhs.lcp_bck_est_space)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_bck_nd_space - rhs.lcp_bck_nd_space)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_frt_ego_arv_est_tm - rhs.lcp_frt_ego_arv_est_tm)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_frt_ego_region_dist - rhs.lcp_frt_ego_region_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_bck_ego_arv_est_tm - rhs.lcp_bck_ego_arv_est_tm)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_bck_ego_region_dist - rhs.lcp_bck_ego_region_dist)) < DBL_EPSILON) && (lhs.lcp_frt_lne_chg_pr_res1 == rhs.lcp_frt_lne_chg_pr_res1) && (lhs.lcp_frt_lne_chg_pr_res2 == rhs.lcp_frt_lne_chg_pr_res2) && (lhs.lcp_frt_lne_chg_pr_res3 == rhs.lcp_frt_lne_chg_pr_res3) && (lhs.lcp_frt_lne_chg_pr_res4 == rhs.lcp_frt_lne_chg_pr_res4) && (lhs.lcp_bck_lne_chg_pr_res1 == rhs.lcp_bck_lne_chg_pr_res1) && (lhs.lcp_bck_lne_chg_pr_res2 == rhs.lcp_bck_lne_chg_pr_res2) && (lhs.lcp_bck_lne_chg_pr_res3 == rhs.lcp_bck_lne_chg_pr_res3) && (lhs.lcp_bck_lne_chg_pr_res4 == rhs.lcp_bck_lne_chg_pr_res4) && (lhs.lcp_ego_frt_obj_id == rhs.lcp_ego_frt_obj_id) && (fabs(static_cast<double>(lhs.lcp_ego_frt_obj_dist - rhs.lcp_ego_frt_obj_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_ego_frt_obj_spd - rhs.lcp_ego_frt_obj_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_ego_frt_obj_len - rhs.lcp_ego_frt_obj_len)) < DBL_EPSILON) && (lhs.lcp_ego_frt_obj_cls == rhs.lcp_ego_frt_obj_cls) && (lhs.lcp_ego_bck_obj_exist_flg == rhs.lcp_ego_bck_obj_exist_flg) && (lhs.lcp_ego_bck_obj_id == rhs.lcp_ego_bck_obj_id) && (fabs(static_cast<double>(lhs.lcp_ego_bck_obj_dist - rhs.lcp_ego_bck_obj_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_ego_bck_obj_spd - rhs.lcp_ego_bck_obj_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_ego_bck_obj_len - rhs.lcp_ego_bck_obj_len)) < DBL_EPSILON) && (lhs.lcp_ego_bck_obj_cls == rhs.lcp_ego_bck_obj_cls) && (lhs.lcp_nr_obj_exist_flg == rhs.lcp_nr_obj_exist_flg) && (lhs.lcp_nr_obj_id == rhs.lcp_nr_obj_id) && (fabs(static_cast<double>(lhs.lcp_nr_obj_dist - rhs.lcp_nr_obj_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_nr_obj_spd - rhs.lcp_nr_obj_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_nr_obj_len - rhs.lcp_nr_obj_len)) < DBL_EPSILON) && (lhs.lcp_nr_obj_cls == rhs.lcp_nr_obj_cls) && (lhs.lcp_nr_frt_obj_exist_flg == rhs.lcp_nr_frt_obj_exist_flg) && (lhs.lcp_nr_frt_obj_id == rhs.lcp_nr_frt_obj_id) && (fabs(static_cast<double>(lhs.lcp_nr_frt_obj_dist - rhs.lcp_nr_frt_obj_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_nr_frt_obj_spd - rhs.lcp_nr_frt_obj_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_nr_frt_obj_len - rhs.lcp_nr_frt_obj_len)) < DBL_EPSILON) && (lhs.lcp_nr_frt_obj_cls == rhs.lcp_nr_frt_obj_cls) && (lhs.lcp_nr_bck_obj_exist_flg == rhs.lcp_nr_bck_obj_exist_flg) && (lhs.lcp_nr_bck_obj_id == rhs.lcp_nr_bck_obj_id) && (fabs(static_cast<double>(lhs.lcp_nr_bck_obj_dist - rhs.lcp_nr_bck_obj_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_nr_bck_obj_spd - rhs.lcp_nr_bck_obj_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lcp_nr_bck_obj_len - rhs.lcp_nr_bck_obj_len)) < DBL_EPSILON) && (lhs.lcp_nr_bck_obj_cls == rhs.lcp_nr_bck_obj_cls);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_PASSAGEOB_H
